<template>
  <div>
    <h3>Edit profile</h3>
    <v-divider class="mb-6"></v-divider>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-text-field
        v-model="profile.firstName"
        outlined
        required
        label="First name"
        :rules="nameRules"
      ></v-text-field>
      <v-text-field
        v-model="profile.lastName"
        outlined
        required
        label="Last name"
        :rules="nameRules"
      ></v-text-field>
      <v-text-field
        v-model="profile.email"
        outlined
        disabled
        readonly
        label="Email"
      ></v-text-field>
      <v-text-field
        v-model="profile.phoneNumber"
        outlined
        required
        label="Phone number"
        :rules="phoneRules"
      ></v-text-field>
      <v-btn color="primary" :disabled="!valid" @click="submit">Save</v-btn>
    </v-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      valid: true,
      profile: {
        firstName: '',
        lastName: '',
        email: '',
        phoneNumber: '',
      },
      nameRules: [(v: string) => !!v || 'Name is required'],
      phoneRules: [
        (v: string) => !!v || 'Phone number is required',
        (v: string) =>
          /^(?:(?:\+|00)33|0)\s*[1-9](?:[\s.-]*\d{2}){4}$/.test(v) ||
          'Phone number must be valid',
      ],
    }
  },
  mounted() {
    this.getProfile()
  },
  methods: {
    submit(): void {
      if ((this.$refs.form as any).validate()) {
        this.$axios.$put(
          'http://delivery.localhost:4000/deliverers/' + this.$store.state.loggedIn, // ! Current logged user ID
          this.profile
        )
      }
    },
    async getProfile() {
      this.profile = await this.$axios.$get(
        'http://delivery.localhost:4000/deliverers/' + this.$store.state.loggedIn // ! Current logged user ID
      )
    },
  },
})
</script>
